Index: uspace/drv/bus/usb/usbmid/usbmid.c
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/bus/usb/usbmid/usbmid.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -45,6 +45,5 @@
 
 /** Callback for DDF USB interface. */
-static int usb_iface_get_interface_impl(ddf_fun_t *fun, devman_handle_t handle,
-    int *iface_no)
+static int usb_iface_get_interface_impl(ddf_fun_t *fun, int *iface_no)
 {
 	assert(fun);
@@ -62,7 +61,7 @@
 /** DDF interface of the child - interface function. */
 static usb_iface_t child_usb_iface = {
-	.get_hc_handle = usb_iface_get_hc_handle_hub_child_impl,
-	.get_address = usb_iface_get_address_hub_impl,
-	.get_interface = usb_iface_get_interface_impl
+	.get_hc_handle = usb_iface_get_hc_handle_device_impl,
+	.get_my_address = usb_iface_get_my_address_forward_impl,
+	.get_my_interface = usb_iface_get_interface_impl,
 };
 
@@ -110,7 +109,7 @@
 	 * class name something humanly understandable.
 	 */
-	rc = asprintf(&child_name, "%s%d",
+	rc = asprintf(&child_name, "%s%hhu",
 	    usb_str_class(interface_descriptor->interface_class),
-	    (int) interface_descriptor->interface_number);
+	    interface_descriptor->interface_number);
 	if (rc < 0) {
 		return ENOMEM;
@@ -123,9 +122,4 @@
 		return ENOMEM;
 	}
-
-	iface->fun = child;
-
-	child->driver_data = iface;
-	child->ops = &child_device_ops;
 
 	rc = usb_device_create_match_ids_from_interface(device_descriptor,
@@ -143,4 +137,8 @@
 	}
 
+	iface->fun = child;
+	child->driver_data = iface;
+	child->ops = &child_device_ops;
+
 	return EOK;
 }
Index: uspace/drv/bus/usb/usbmid/usbmid.h
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.h	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/bus/usb/usbmid/usbmid.h	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -51,5 +51,5 @@
 	ddf_fun_t *fun;
 	/** Interface descriptor. */
-	usb_standard_interface_descriptor_t *interface;
+	const usb_standard_interface_descriptor_t *interface;
 	/** Interface number. */
 	int interface_no;
Index: uspace/drv/bus/usb/vhc/connhost.c
===================================================================
--- uspace/drv/bus/usb/vhc/connhost.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/bus/usb/vhc/connhost.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -57,20 +57,12 @@
  * @return Error code.
  */
-static int request_address(ddf_fun_t *fun, usb_speed_t speed,
-    usb_address_t *address)
-{
-	VHC_DATA(vhc, fun);
-
-	usb_address_t addr = usb_device_manager_get_free_address(
-	    &vhc->dev_manager, USB_SPEED_HIGH);
-	if (addr < 0) {
-		return addr;
-	}
-
-	if (address != NULL) {
-		*address = addr;
-	}
-
-	return EOK;
+static int request_address(ddf_fun_t *fun, usb_address_t *address, bool strict,
+    usb_speed_t speed)
+{
+	VHC_DATA(vhc, fun);
+
+	assert(address);
+	return usb_device_manager_request_address(
+	    &vhc->dev_manager, address, strict, speed);
 }
 
@@ -88,5 +80,5 @@
 	usb_log_debug("Binding handle %" PRIun " to address %d.\n",
 	    handle, address);
-	usb_device_manager_bind(&vhc->dev_manager, address, handle);
+	usb_device_manager_bind_address(&vhc->dev_manager, address, handle);
 
 	return EOK;
@@ -118,5 +110,5 @@
 	VHC_DATA(vhc, fun);
 	usb_log_debug("Releasing address %d...\n", address);
-	usb_device_manager_release(&vhc->dev_manager, address);
+	usb_device_manager_release_address(&vhc->dev_manager, address);
 
 	return ENOTSUP;
@@ -136,5 +128,5 @@
  */
 static int register_endpoint(ddf_fun_t *fun,
-    usb_address_t address, usb_speed_t speed, usb_endpoint_t endpoint,
+    usb_address_t address, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
     size_t max_packet_size, unsigned int interval)
@@ -479,6 +471,5 @@
 }
 
-static int tell_address(ddf_fun_t *fun, devman_handle_t handle,
-    usb_address_t *address)
+static int tell_address(ddf_fun_t *fun, usb_address_t *address)
 {
 	UNSUPPORTED("tell_address");
@@ -497,12 +488,9 @@
 }
 
-static int tell_address_rh(ddf_fun_t *root_hub_fun, devman_handle_t handle,
-    usb_address_t *address)
+static int tell_address_rh(ddf_fun_t *root_hub_fun, usb_address_t *address)
 {
 	VHC_DATA(vhc, root_hub_fun);
 
-	if (handle == 0) {
-		handle = root_hub_fun->handle;
-	}
+	devman_handle_t handle = root_hub_fun->handle;
 
 	usb_log_debug("tell_address_rh(handle=%" PRIun ")\n", handle);
@@ -520,5 +508,5 @@
 	.request_address = request_address,
 	.bind_address = bind_address,
-	.find_by_address = find_by_address,
+	.get_handle = find_by_address,
 	.release_address = release_address,
 
@@ -532,10 +520,10 @@
 usb_iface_t vhc_usb_iface = {
 	.get_hc_handle = usb_iface_get_hc_handle_hc_impl,
-	.get_address = tell_address
+	.get_my_address = tell_address
 };
 
 usb_iface_t rh_usb_iface = {
 	.get_hc_handle = usb_iface_get_hc_handle_rh_impl,
-	.get_address = tell_address_rh
+	.get_my_address = tell_address_rh
 };
 
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/bus/usb/vhc/main.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -58,5 +58,5 @@
 };
 
-static int vhc_add_device(ddf_dev_t *dev)
+static int vhc_dev_add(ddf_dev_t *dev)
 {
 	static int vhc_count = 0;
@@ -80,5 +80,5 @@
 		return rc;
 	}
-	usb_device_manager_init(&data->dev_manager);
+	usb_device_manager_init(&data->dev_manager, USB_SPEED_MAX);
 
 	ddf_fun_t *hc = ddf_fun_create(dev, fun_exposed, "hc");
@@ -131,5 +131,5 @@
 
 static driver_ops_t vhc_driver_ops = {
-	.add_device = vhc_add_device,
+	.dev_add = vhc_dev_add,
 };
 
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/char/ns8250/ns8250.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -223,10 +223,10 @@
 };
 
-static int ns8250_add_device(ddf_dev_t *dev);
+static int ns8250_dev_add(ddf_dev_t *dev);
 static int ns8250_dev_remove(ddf_dev_t *dev);
 
 /** The serial port device driver's standard operations. */
 static driver_ops_t ns8250_ops = {
-	.add_device = &ns8250_add_device,
+	.dev_add = &ns8250_dev_add,
 	.dev_remove = &ns8250_dev_remove
 };
@@ -717,5 +717,5 @@
 }
 
-/** The add_device callback method of the serial port driver.
+/** The dev_add callback method of the serial port driver.
  *
  * Probe and initialize the newly added device.
@@ -723,5 +723,5 @@
  * @param dev		The serial port device.
  */
-static int ns8250_add_device(ddf_dev_t *dev)
+static int ns8250_dev_add(ddf_dev_t *dev)
 {
 	ns8250_t *ns = NULL;
@@ -730,5 +730,5 @@
 	int rc;
 	
-	ddf_msg(LVL_DEBUG, "ns8250_add_device %s (handle = %d)",
+	ddf_msg(LVL_DEBUG, "ns8250_dev_add %s (handle = %d)",
 	    dev->name, (int) dev->handle);
 	
Index: uspace/drv/infrastructure/root/root.c
===================================================================
--- uspace/drv/infrastructure/root/root.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/infrastructure/root/root.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -66,5 +66,5 @@
 #define VIRTUAL_FUN_MATCH_SCORE 100
 
-static int root_add_device(ddf_dev_t *dev);
+static int root_dev_add(ddf_dev_t *dev);
 static int root_fun_online(ddf_fun_t *fun);
 static int root_fun_offline(ddf_fun_t *fun);
@@ -72,5 +72,5 @@
 /** The root device driver's standard operations. */
 static driver_ops_t root_ops = {
-	.add_device = &root_add_device,
+	.dev_add = &root_dev_add,
 	.fun_online = &root_fun_online,
 	.fun_offline = &root_fun_offline
@@ -198,7 +198,7 @@
  *			of HW and pseudo devices).
  */
-static int root_add_device(ddf_dev_t *dev)
-{
-	ddf_msg(LVL_DEBUG, "root_add_device, device handle=%" PRIun,
+static int root_dev_add(ddf_dev_t *dev)
+{
+	ddf_msg(LVL_DEBUG, "root_dev_add, device handle=%" PRIun,
 	    dev->handle);
 
Index: uspace/drv/infrastructure/rootmac/rootmac.c
===================================================================
--- uspace/drv/infrastructure/rootmac/rootmac.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/infrastructure/rootmac/rootmac.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -125,5 +125,5 @@
  *
  */
-static int rootmac_add_device(ddf_dev_t *dev)
+static int rootmac_dev_add(ddf_dev_t *dev)
 {
 	/* Register functions */
@@ -136,5 +136,5 @@
 /** The root device driver's standard operations. */
 static driver_ops_t rootmac_ops = {
-	.add_device = &rootmac_add_device
+	.dev_add = &rootmac_dev_add
 };
 
Index: uspace/drv/infrastructure/rootpc/rootpc.c
===================================================================
--- uspace/drv/infrastructure/rootpc/rootpc.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/infrastructure/rootpc/rootpc.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -63,10 +63,10 @@
 } rootpc_fun_t;
 
-static int rootpc_add_device(ddf_dev_t *dev);
+static int rootpc_dev_add(ddf_dev_t *dev);
 static void root_pc_init(void);
 
 /** The root device driver's standard operations. */
 static driver_ops_t rootpc_ops = {
-	.add_device = &rootpc_add_device
+	.dev_add = &rootpc_dev_add
 };
 
@@ -175,7 +175,7 @@
  * @return		Zero on success, negative error number otherwise.
  */
-static int rootpc_add_device(ddf_dev_t *dev)
-{
-	ddf_msg(LVL_DEBUG, "rootpc_add_device, device handle = %d",
+static int rootpc_dev_add(ddf_dev_t *dev)
+{
+	ddf_msg(LVL_DEBUG, "rootpc_dev_add, device handle = %d",
 	    (int)dev->handle);
 	
Index: uspace/drv/infrastructure/rootvirt/rootvirt.c
===================================================================
--- uspace/drv/infrastructure/rootvirt/rootvirt.c	(revision 3b71e84dce17092725ada79fab0ccaf7ded86420)
+++ uspace/drv/infrastructure/rootvirt/rootvirt.c	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -62,5 +62,5 @@
 };
 
-static int rootvirt_add_device(ddf_dev_t *dev);
+static int rootvirt_dev_add(ddf_dev_t *dev);
 static int rootvirt_dev_remove(ddf_dev_t *dev);
 static int rootvirt_fun_online(ddf_fun_t *fun);
@@ -68,5 +68,5 @@
 
 static driver_ops_t rootvirt_ops = {
-	.add_device = &rootvirt_add_device,
+	.dev_add = &rootvirt_dev_add,
 	.dev_remove = &rootvirt_dev_remove,
 	.fun_online = &rootvirt_fun_online,
@@ -172,5 +172,5 @@
 
 
-static int rootvirt_add_device(ddf_dev_t *dev)
+static int rootvirt_dev_add(ddf_dev_t *dev)
 {
 	rootvirt_t *rootvirt;
@@ -183,5 +183,5 @@
 	}
 
-	ddf_msg(LVL_DEBUG, "add_device(handle=%d)", (int)dev->handle);
+	ddf_msg(LVL_DEBUG, "dev_add(handle=%d)", (int)dev->handle);
 
 	rootvirt = ddf_dev_data_alloc(dev, sizeof(rootvirt_t));
Index: uspace/drv/nic/e1k/Makefile
===================================================================
--- uspace/drv/nic/e1k/Makefile	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
+++ uspace/drv/nic/e1k/Makefile	(revision 7aaed09d88be49fac8360d3017e3328ed9b0635c)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2011 Radim Vansa
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = $(LIBDRV_PREFIX)/libdrv.a $(LIBNET_PREFIX)/libnet.a $(LIBNIC_PREFIX)/libnic.a
+EXTRA_CFLAGS += -I$(LIBDRV_PREFIX)/include -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include
+BINARY = e1k
+
+SOURCES = \
+	e1k.c
+
+include $(USPACE_PREFIX)/Makefile.common
